package com.neusoft.smart.pos.strategy.persistent.domain;

import java.util.ArrayList;
import java.util.List;

public class BeanTypeDictExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer offset;

    private Integer limit;

    public BeanTypeDictExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        this.offset = null;
        this.limit = null;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getLimit() {
        return this.limit;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public BeanTypeDictExample page(int offset, int limit) {
        this.offset = offset;
        this.limit = limit;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIsNull() {
            addCriterion("bean_type is null");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIsNotNull() {
            addCriterion("bean_type is not null");
            return (Criteria) this;
        }

        public Criteria andBeanTypeEqualTo(String value) {
            addCriterion("bean_type =", value, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeNotEqualTo(String value) {
            addCriterion("bean_type <>", value, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeGreaterThan(String value) {
            addCriterion("bean_type >", value, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeGreaterThanOrEqualTo(String value) {
            addCriterion("bean_type >=", value, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeLessThan(String value) {
            addCriterion("bean_type <", value, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeLessThanOrEqualTo(String value) {
            addCriterion("bean_type <=", value, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeLike(String value) {
            addCriterion("bean_type like", value, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeNotLike(String value) {
            addCriterion("bean_type not like", value, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeIn(List<String> values) {
            addCriterion("bean_type in", values, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeNotIn(List<String> values) {
            addCriterion("bean_type not in", values, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeBetween(String value1, String value2) {
            addCriterion("bean_type between", value1, value2, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanTypeNotBetween(String value1, String value2) {
            addCriterion("bean_type not between", value1, value2, "beanType");
            return (Criteria) this;
        }

        public Criteria andBeanNameIsNull() {
            addCriterion("bean_name is null");
            return (Criteria) this;
        }

        public Criteria andBeanNameIsNotNull() {
            addCriterion("bean_name is not null");
            return (Criteria) this;
        }

        public Criteria andBeanNameEqualTo(String value) {
            addCriterion("bean_name =", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameNotEqualTo(String value) {
            addCriterion("bean_name <>", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameGreaterThan(String value) {
            addCriterion("bean_name >", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameGreaterThanOrEqualTo(String value) {
            addCriterion("bean_name >=", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameLessThan(String value) {
            addCriterion("bean_name <", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameLessThanOrEqualTo(String value) {
            addCriterion("bean_name <=", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameLike(String value) {
            addCriterion("bean_name like", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameNotLike(String value) {
            addCriterion("bean_name not like", value, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameIn(List<String> values) {
            addCriterion("bean_name in", values, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameNotIn(List<String> values) {
            addCriterion("bean_name not in", values, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameBetween(String value1, String value2) {
            addCriterion("bean_name between", value1, value2, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanNameNotBetween(String value1, String value2) {
            addCriterion("bean_name not between", value1, value2, "beanName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameIsNull() {
            addCriterion("bean_display_name is null");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameIsNotNull() {
            addCriterion("bean_display_name is not null");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameEqualTo(String value) {
            addCriterion("bean_display_name =", value, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameNotEqualTo(String value) {
            addCriterion("bean_display_name <>", value, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameGreaterThan(String value) {
            addCriterion("bean_display_name >", value, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameGreaterThanOrEqualTo(String value) {
            addCriterion("bean_display_name >=", value, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameLessThan(String value) {
            addCriterion("bean_display_name <", value, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameLessThanOrEqualTo(String value) {
            addCriterion("bean_display_name <=", value, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameLike(String value) {
            addCriterion("bean_display_name like", value, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameNotLike(String value) {
            addCriterion("bean_display_name not like", value, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameIn(List<String> values) {
            addCriterion("bean_display_name in", values, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameNotIn(List<String> values) {
            addCriterion("bean_display_name not in", values, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameBetween(String value1, String value2) {
            addCriterion("bean_display_name between", value1, value2, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDisplayNameNotBetween(String value1, String value2) {
            addCriterion("bean_display_name not between", value1, value2, "beanDisplayName");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionIsNull() {
            addCriterion("bean_description is null");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionIsNotNull() {
            addCriterion("bean_description is not null");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionEqualTo(String value) {
            addCriterion("bean_description =", value, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionNotEqualTo(String value) {
            addCriterion("bean_description <>", value, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionGreaterThan(String value) {
            addCriterion("bean_description >", value, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionGreaterThanOrEqualTo(String value) {
            addCriterion("bean_description >=", value, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionLessThan(String value) {
            addCriterion("bean_description <", value, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionLessThanOrEqualTo(String value) {
            addCriterion("bean_description <=", value, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionLike(String value) {
            addCriterion("bean_description like", value, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionNotLike(String value) {
            addCriterion("bean_description not like", value, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionIn(List<String> values) {
            addCriterion("bean_description in", values, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionNotIn(List<String> values) {
            addCriterion("bean_description not in", values, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionBetween(String value1, String value2) {
            addCriterion("bean_description between", value1, value2, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanDescriptionNotBetween(String value1, String value2) {
            addCriterion("bean_description not between", value1, value2, "beanDescription");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateIsNull() {
            addCriterion("bean_parameter_template is null");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateIsNotNull() {
            addCriterion("bean_parameter_template is not null");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateEqualTo(String value) {
            addCriterion("bean_parameter_template =", value, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateNotEqualTo(String value) {
            addCriterion("bean_parameter_template <>", value, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateGreaterThan(String value) {
            addCriterion("bean_parameter_template >", value, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateGreaterThanOrEqualTo(String value) {
            addCriterion("bean_parameter_template >=", value, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateLessThan(String value) {
            addCriterion("bean_parameter_template <", value, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateLessThanOrEqualTo(String value) {
            addCriterion("bean_parameter_template <=", value, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateLike(String value) {
            addCriterion("bean_parameter_template like", value, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateNotLike(String value) {
            addCriterion("bean_parameter_template not like", value, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateIn(List<String> values) {
            addCriterion("bean_parameter_template in", values, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateNotIn(List<String> values) {
            addCriterion("bean_parameter_template not in", values, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateBetween(String value1, String value2) {
            addCriterion("bean_parameter_template between", value1, value2, "beanParameterTemplate");
            return (Criteria) this;
        }

        public Criteria andBeanParameterTemplateNotBetween(String value1, String value2) {
            addCriterion("bean_parameter_template not between", value1, value2, "beanParameterTemplate");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}